PF-build.sh 45 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_37
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  140. #### Start check if OSTYPE is supported
  141. OS_FOUND=$( command -v uname)
  142. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  143. linux*)
  144. TARGET_OS="linux"
  145. ;;
  146. msys*|cygwin*|mingw*)
  147. # or possible 'bash on windows'
  148. TARGET_OS='windows'
  149. ;;
  150. nt|win*)
  151. TARGET_OS='windows'
  152. ;;
  153. *)
  154. TARGET_OS='unknown'
  155. ;;
  156. esac
  157. # Windows
  158. if [ $TARGET_OS == "windows" ]; then
  159. if [ $(uname -m) == "x86_64" ]; then
  160. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  161. Processor="64"
  162. elif [ $(uname -m) == "i386" ]; then
  163. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  164. Processor="32"
  165. else
  166. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  167. echo "Please refer to the notes of build.sh$(tput sgr0)"
  168. exit 1
  169. fi
  170. # Linux
  171. elif [ $TARGET_OS == "linux" ]; then
  172. if [ $(uname -m) == "x86_64" ]; then
  173. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  174. Processor="64"
  175. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  176. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  177. Processor="32"
  178. else
  179. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  180. echo "Please refer to the notes of build.sh$(tput sgr0)"
  181. exit 1
  182. fi
  183. else
  184. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  185. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  186. echo "Read the notes of build.sh$(tput sgr0)"
  187. exit 1
  188. fi
  189. sleep 2
  190. #### End check if OSTYPE is supported
  191. #### Prepare bash environment and check if wget, zip and other needed things are available
  192. # Check wget
  193. if ! type wget > /dev/null; then
  194. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  195. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  196. exit 2
  197. fi
  198. # Check for zip
  199. if ! type zip > /dev/null; then
  200. if [ $TARGET_OS == "windows" ]; then
  201. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  202. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  203. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  204. echo "Run git Bash under Administrator privilege and"
  205. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  206. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  207. exit 3
  208. elif [ $TARGET_OS == "linux" ]; then
  209. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  210. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  211. #sudo apt-get update && apt-get install zip
  212. exit 3
  213. fi
  214. fi
  215. # Check python ... needed during language build
  216. if ! type python > /dev/null; then
  217. if [ $TARGET_OS == "windows" ]; then
  218. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  219. exit 4
  220. elif [ $TARGET_OS == "linux" ]; then
  221. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  222. echo "As Python 2.x will not be maintained from 2020 please,"
  223. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  224. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  225. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  226. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  227. exit 4
  228. fi
  229. fi
  230. # Check gawk ... needed during language build
  231. if ! type gawk > /dev/null; then
  232. if [ $TARGET_OS == "linux" ]; then
  233. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  234. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  235. #sudo apt-get update && apt-get install gawk
  236. exit 5
  237. fi
  238. fi
  239. #### End prepare bash / Linux environment
  240. #### Set build environment
  241. ARDUINO_ENV="1.8.5"
  242. BUILD_ENV="1.0.6"
  243. BOARD="prusa_einsy_rambo"
  244. BOARD_PACKAGE_NAME="PrusaResearch"
  245. BOARD_VERSION="1.0.3"
  246. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  247. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  248. BOARD_FILENAME="prusa3dboards"
  249. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  250. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  251. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  252. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  253. LIB="PrusaLibrary"
  254. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  255. # List few useful data
  256. echo
  257. echo "Script path :" $SCRIPT_PATH
  258. echo "OS :" $OS
  259. echo "OS type :" $TARGET_OS
  260. echo ""
  261. echo "Arduino IDE :" $ARDUINO_ENV
  262. echo "Build env :" $BUILD_ENV
  263. echo "Board :" $BOARD
  264. echo "Package name:" $BOARD_PACKAGE_NAME
  265. echo "Board v. :" $BOARD_VERSION
  266. echo "Specific Lib:" $LIB
  267. echo ""
  268. #### Start prepare building environment
  269. #Check if build exists and creates it if not
  270. if [ ! -d "../PF-build-dl" ]; then
  271. mkdir ../PF-build-dl || exit 6
  272. fi
  273. cd ../PF-build-dl || exit 7
  274. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  275. # Check if PF-build-env-<version> exists and downloads + creates it if not
  276. # The build environment is based on the supported Arduino IDE portable version with some changes
  277. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  278. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  279. mkdir ../PF-build-env-$BUILD_ENV
  280. sleep 5
  281. fi
  282. # Download and extract supported Arduino IDE depending on OS
  283. # Windows
  284. if [ $TARGET_OS == "windows" ]; then
  285. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  286. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  287. sleep 2
  288. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  289. echo "$(tput sgr 0)"
  290. fi
  291. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  292. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  293. sleep 2
  294. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 8
  295. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  296. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  297. echo "$(tput sgr0)"
  298. fi
  299. fi
  300. # Linux
  301. if [ $TARGET_OS == "linux" ]; then
  302. # 32 or 64 bit version
  303. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  304. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  305. sleep 2
  306. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  307. echo "$(tput sgr 0)"
  308. fi
  309. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  310. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  311. sleep 2
  312. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  313. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  314. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  315. echo "$(tput sgr0)"
  316. fi
  317. fi
  318. # Make Arduino IDE portable
  319. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  320. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  321. fi
  322. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  323. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  324. fi
  325. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  326. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  327. fi
  328. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  329. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  330. fi
  331. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  332. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  333. fi
  334. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  335. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  336. fi
  337. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  338. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  339. fi
  340. # Change Arduino IDE preferences
  341. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  342. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  343. sleep 2
  344. echo "update.check"
  345. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  346. echo "board"
  347. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  348. echo "editor.linenumbers"
  349. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  350. echo "boardsmanager.additional.urls"
  351. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  352. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  353. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  354. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  355. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  356. echo "$(tput sgr0)"
  357. fi
  358. # Download and extract Prusa Firmware related parts
  359. # Download and extract PrusaResearchRambo board
  360. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  361. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  362. sleep 2
  363. wget $BOARD_FILE_URL || exit 9
  364. fi
  365. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  366. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  367. sleep 2
  368. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  369. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  370. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  371. fi
  372. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  373. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  374. fi
  375. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  376. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  377. fi
  378. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  379. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  380. fi
  381. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  382. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  383. echo "$(tput sgr 0)"
  384. fi
  385. # Download and extract Prusa Firmware specific library files
  386. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  387. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  388. sleep 2
  389. wget $PF_BUILD_FILE_URL || exit 11
  390. echo "$(tput sgr 0)"
  391. fi
  392. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  393. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  394. sleep 2
  395. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  396. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  397. echo "$(tput sgr0)"
  398. fi
  399. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  400. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  401. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  402. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  403. sleep 2
  404. fi
  405. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  406. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  407. sleep 2
  408. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  409. sleep 2
  410. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  411. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  412. echo "$(tput sgr0)"
  413. fi
  414. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  415. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  416. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  417. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  418. sleep 2
  419. echo "$(tput sgr0)"
  420. exit 13
  421. fi
  422. #### End prepare building
  423. #### Start
  424. cd $SCRIPT_PATH
  425. # Check if git is available
  426. if type git > /dev/null; then
  427. git_available="1"
  428. fi
  429. while getopts v:l:d:b:o:c:p:n:?h flag
  430. do
  431. case "${flag}" in
  432. v) variant_flag=${OPTARG};;
  433. l) language_flag=${OPTARG};;
  434. d) devel_flag=${OPTARG};;
  435. b) build_flag=${OPTARG};;
  436. o) output_flag=${OPTARG};;
  437. c) clean_flag=${OPTARG};;
  438. p) prusa_flag=${OPTARG};;
  439. n) new_build_flag=${OPTARG};;
  440. ?) help_flag=1;;
  441. h) help_flag=1;;
  442. esac
  443. done
  444. #echo "variant_flag: $variant_flag";
  445. #echo "language_flag: $language_flag";
  446. #echo "devel_flag: $devel_flag";
  447. #echo "build_flag: $build_flag";
  448. #echo "output_flag: $output_flag";
  449. #echo "help_flag: $help_flag"
  450. #echo "clean_flag: $clean_flag"
  451. #echo "prusa_flag: $prusa_flag"
  452. #echo "new_build_flag: $new_build_flag"
  453. #
  454. # '?' 'h' argument usage and help
  455. if [ "$help_flag" == "1" ] ; then
  456. echo "***************************************"
  457. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  458. echo "***************************************"
  459. echo "Arguments:"
  460. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  461. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  462. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  463. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  464. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  465. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  466. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  467. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  468. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  469. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  470. echo
  471. echo "Brief USAGE:"
  472. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  473. echo
  474. echo "Example:"
  475. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  476. echo " Will build all variants as multi language and final GOLD version"
  477. echo
  478. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  479. echo " Will build MK3S multi language final GOLD firmware "
  480. echo " with current commit count number and output extra information,"
  481. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  482. echo
  483. exit 14
  484. fi
  485. #
  486. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  487. if [ -z "$variant_flag" ] ; then
  488. # Select which variant of the Prusa Firmware will be compiled, like
  489. PS3="Select a variant: "
  490. while IFS= read -r -d $'\0' f; do
  491. options[i++]="$f"
  492. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  493. select opt in "${options[@]}" "All" "Quit"; do
  494. case $opt in
  495. *.h)
  496. VARIANT=$(basename "$opt" ".h")
  497. VARIANTS[i++]="$opt"
  498. break
  499. ;;
  500. "All")
  501. VARIANT="All"
  502. VARIANTS=${options[*]}
  503. break
  504. ;;
  505. "Quit")
  506. echo "You chose to stop"
  507. exit 20
  508. ;;
  509. *)
  510. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  511. ;;
  512. esac
  513. done
  514. else
  515. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  516. VARIANTS=$variant_flag
  517. elif [ "$variant_flag" == "All" ] ; then
  518. while IFS= read -r -d $'\0' f; do
  519. options[i++]="$f"
  520. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  521. VARIANT="All"
  522. VARIANTS=${options[*]}
  523. else
  524. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  525. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  526. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  527. echo "$(tput sgr0)"
  528. exit 21
  529. fi
  530. fi
  531. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  532. #Check default language mode
  533. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  534. if [ -z "$language_flag" ] ; then
  535. PS3="Select a language: "
  536. echo
  537. echo "Which lang-build do you want?"
  538. select yn in "Multi languages" "English only"; do
  539. case $yn in
  540. "Multi languages")
  541. LANGUAGES="ALL"
  542. break
  543. ;;
  544. "English only")
  545. LANGUAGES="EN_ONLY"
  546. break
  547. ;;
  548. *)
  549. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  550. ;;
  551. esac
  552. done
  553. else
  554. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  555. LANGUAGES=$language_flag
  556. else
  557. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  558. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  559. exit 22
  560. fi
  561. fi
  562. #Check if DEV_STATUS is selected via argument '-d'
  563. if [ ! -z "$devel_flag" ] ; then
  564. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  565. DEV_STATUS_SELECTED=$devel_flag
  566. else
  567. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  568. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  569. exit 23
  570. fi
  571. fi
  572. #Check if Build is selected via argument '-b'
  573. if [ ! -z "$build_flag" ] ; then
  574. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  575. echo "Build changed to $build_flag"
  576. BUILD=$(git rev-list --count HEAD)
  577. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  578. BUILD=$build_flag
  579. else
  580. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  581. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  582. exit 24
  583. fi
  584. echo "New Build number is: $BUILD"
  585. fi
  586. # check if script has been started with arguments
  587. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  588. OUTPUT=1
  589. else
  590. OUTPUT=0
  591. fi
  592. #echo "Output is:" $OUTPUT
  593. #Check git branch has changed
  594. if [ ! -z "git_available" ]; then
  595. BRANCH=""
  596. CLEAN_PF_FW_BUILD=0
  597. else
  598. BRANCH=$(git branch --show-current)
  599. echo "Current branch is:" $BRANCH
  600. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  601. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  602. echo "created PF-build.branch file"
  603. else
  604. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  605. echo "Previous branch was:" $PRE_BRANCH
  606. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  607. CLEAN_PF_FW_BUILD=1
  608. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  609. fi
  610. fi
  611. fi
  612. #Set BUILD_ENV_PATH
  613. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  614. BUILD_ENV_PATH="$( pwd -P )"
  615. cd ../..
  616. #Checkif BUILD_PATH exists and if not creates it
  617. if [ ! -d "Prusa-Firmware-build" ]; then
  618. mkdir Prusa-Firmware-build || exit 26
  619. fi
  620. #Set the BUILD_PATH for Arduino IDE
  621. cd Prusa-Firmware-build || exit 27
  622. BUILD_PATH="$( pwd -P )"
  623. #Check git branch has changed
  624. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  625. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  626. rm -r *
  627. else
  628. echo "Nothing to clean up"
  629. fi
  630. for v in ${VARIANTS[*]}
  631. do
  632. VARIANT=$(basename "$v" ".h")
  633. # Find firmware version in Configuration.h file and use it to generate the hex filename
  634. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  635. if [ -z "$BUILD" ] ; then
  636. # Find build version in Configuration.h file and use it to generate the hex filename
  637. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  638. else
  639. # Find and replace build version in Configuration.h file
  640. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  641. echo "Original build number: $BUILD_ORG"
  642. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  643. fi
  644. # Check if the motherboard is an EINSY and if so only one hex file will generated
  645. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  646. # Check development status
  647. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  648. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  649. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  650. DEV_STATUS="RC"
  651. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  652. DEV_STATUS="ALPHA"
  653. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  654. DEV_STATUS="BETA"
  655. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  656. DEV_STATUS="DEVEL"
  657. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  658. DEV_STATUS="DEBUG"
  659. else
  660. DEV_STATUS="UNKNOWN"
  661. echo
  662. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  663. PS3="Select YES only if source code is tested and trusted: "
  664. select yn in "Yes" "No"; do
  665. case $yn in
  666. Yes)
  667. DEV_STATUS="GOLD"
  668. DEV_STATUS_SELECTED="GOLD"
  669. break
  670. ;;
  671. No)
  672. DEV_STATUS="UNKNOWN"
  673. DEV_STATUS_SELECTED="UNKNOWN"
  674. break
  675. ;;
  676. *)
  677. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  678. ;;
  679. esac
  680. done
  681. fi
  682. else
  683. DEV_STATUS=$DEV_STATUS_SELECTED
  684. fi
  685. #Prepare hex files folders
  686. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  687. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  688. fi
  689. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  690. #Check if exactly the same hexfile already exists
  691. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  692. echo ""
  693. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  694. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  695. if [ $OUTPUT == "1" ] ; then
  696. read -t 10 -p "Press Enter to continue..."
  697. fi
  698. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  699. echo ""
  700. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  701. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  702. if [ $OUTPUT == "1" ] ; then
  703. read -t 10 -p "Press Enter to continue..."
  704. fi
  705. fi
  706. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  707. echo ""
  708. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  709. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  710. if [ $OUTPUT == "1" ] ; then
  711. read -t 10 -p "Press Enter to continue..."
  712. fi
  713. fi
  714. #List some useful data
  715. echo "$(tput setaf 2)$(tput setab 7) "
  716. echo "Variant :" $VARIANT
  717. echo "Firmware :" $FW
  718. echo "Build # :" $BUILD
  719. echo "Dev Check :" $DEV_CHECK
  720. echo "DEV Status :" $DEV_STATUS
  721. echo "Motherboard:" $MOTHERBOARD
  722. echo "Languages :" $LANGUAGES
  723. echo "Hex-file Folder:" $OUTPUT_FOLDER
  724. echo "$(tput sgr0)"
  725. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  726. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  727. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  728. else
  729. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  730. if [ $OUTPUT == "1" ] ; then
  731. read -t 10 -p "Press Enter to continue..."
  732. fi
  733. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  734. fi
  735. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  736. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  737. # set FW_REPOSITORY
  738. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  739. #Prepare English only or multi-language version to be build
  740. if [ $LANGUAGES == "EN_ONLY" ]; then
  741. echo " "
  742. echo "English only language firmware will be built"
  743. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  744. echo " "
  745. else
  746. echo " "
  747. echo "Multi-language firmware will be built"
  748. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  749. echo " "
  750. fi
  751. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  752. # if [ $TARGET_OS == "windows" ]; then
  753. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  754. # fi
  755. #### End of Prepare building
  756. #### Start building
  757. export ARDUINO=$BUILD_ENV_PATH
  758. #echo $BUILD_ENV_PATH
  759. #export BUILDER=$ARDUINO/arduino-builder
  760. echo
  761. #read -t 5 -p "Press Enter..."
  762. echo
  763. echo "Start to build Prusa Firmware ..."
  764. echo "Using variant $VARIANT$(tput setaf 3)"
  765. if [ $OUTPUT == "1" ] ; then
  766. sleep 2
  767. fi
  768. #New fresh PF-Firmware-build
  769. if [ "$new_build_flag" == "1" ]; then
  770. rm -r -f $BUILD_PATH/* || exit 36
  771. fi
  772. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  773. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  774. echo "$(tput sgr 0)"
  775. if [ $LANGUAGES == "ALL" ]; then
  776. echo "$(tput setaf 2)"
  777. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  778. echo "$(tput sgr 0)"
  779. if [ $OUTPUT == "1" ] ; then
  780. sleep 2
  781. fi
  782. cd $SCRIPT_PATH/lang
  783. echo "$(tput setaf 3)"
  784. ./config.sh || exit 31
  785. echo "$(tput sgr 0)"
  786. # Check if previous languages and firmware build exist and if so clean them up
  787. if [ -f "lang_en.tmp" ]; then
  788. echo ""
  789. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  790. if [ $OUTPUT == "1" ] ; then
  791. read -t 10 -p "Press Enter to continue..."
  792. fi
  793. echo "$(tput setaf 3)"
  794. ./lang-clean.sh
  795. echo "$(tput sgr 0)"
  796. fi
  797. if [ -f "progmem.out" ]; then
  798. echo ""
  799. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  800. if [ $OUTPUT == "1" ] ; then
  801. read -t 10 -p "Press Enter to continue..."
  802. fi
  803. echo "$(tput setaf 3)"
  804. ./fw-clean.sh
  805. echo "$(tput sgr 0)"
  806. fi
  807. # build languages
  808. echo "$(tput setaf 3)"
  809. ./lang-build.sh || exit 32
  810. #Community language support
  811. ./lang-community.sh || exit 33
  812. # Combine compiled firmware with languages
  813. ./fw-build.sh || exit 34
  814. cp not_tran.txt not_tran_$VARIANT.txt
  815. cp not_used.txt not_used_$VARIANT.txt
  816. echo "$(tput sgr 0)"
  817. # Check if the motherboard is an EINSY and if so only one hex file will generated
  818. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  819. # If the motherboard is an EINSY just copy one hexfile
  820. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  821. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  822. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  823. else
  824. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  825. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  826. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  827. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  828. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  829. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  830. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  831. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  832. if [ $TARGET_OS == "windows" ]; then
  833. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  834. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  835. elif [ $TARGET_OS == "linux" ]; then
  836. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  837. fi
  838. fi
  839. # Cleanup after build
  840. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  841. echo "$(tput setaf 3)"
  842. ./fw-clean.sh || exit 35
  843. ./lang-clean.sh || exit 36
  844. echo "$(tput sgr 0)"
  845. fi
  846. else
  847. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  848. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 37
  849. fi
  850. # Cleanup Firmware
  851. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  852. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 38
  853. fi
  854. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  855. then
  856. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  857. fi
  858. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  859. then
  860. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  861. fi
  862. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  863. then
  864. rm $SCRIPT_PATH/lang/not_tran.txt
  865. fi
  866. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  867. then
  868. rm $SCRIPT_PATH/lang/not_used.txt
  869. fi
  870. #New fresh PF-Firmware-build
  871. if [ "$new_build_flag" == "1" ]; then
  872. rm -r -f $BUILD_PATH/* || exit 39
  873. fi
  874. # Restore files to previous state
  875. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  876. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  877. if [ ! -z "$BUILD_ORG" ] ; then
  878. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  879. fi
  880. echo $MULTI_LANGUAGE_CHECK
  881. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  882. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  883. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  884. if [ $OUTPUT == "1" ] ; then
  885. sleep 5
  886. fi
  887. done
  888. # Switch to hex path and list build files
  889. cd $SCRIPT_PATH
  890. cd ..
  891. echo "$(tput setaf 2) "
  892. echo " "
  893. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  894. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  895. #### End building